MRED(1)

NAME
mred - The PLT Graphical Scheme implementation

SYNOPSIS
mred [ Xoption ... ] [ option ... ] [ argument ... ]

DESCRIPTION
MrEd is the PLT's graphical Scheme implementation. It embeds and extends MzScheme with a graphical user interface (GUI) toolbox.

DrScheme is the graphical development environment for creating MzScheme and MrEd applications.

X OPTIONS
When running in X11, MrEd accepts the following standard Xoptions: -display disp, -geometry geom, -bg color, -background color, -fg color, -foreground color, -fn font, -font font, -iconic, -name name, -rv, -reverse, +rv, -selectionTimeout time, -synchronous, -title name, -xnllanguage lang, -xrm file. These options must appear before all other options.

STARTUP FILE AND EXPRESSION OPTIONS

-e expr, --eval expr
    Evaluates expr after MrEd starts.

-f file, --load file
    Loads file after MrEd starts.

-d file, --load-cd file
    Load/cds file after MrEd starts.

-t file, --require file
    Requires file after MrEd starts.

-F, --Load
    Loads all remaining arguments after MrEd starts.

-D, --Load-cd
    Load/cds all remaining arguments after MrEd starts.

-T, --Require
    Requires all remaining arguments after MrEd starts.

-l file, --mzlib file
    Same as -e '(require (lib " file "))'.

-L file coll
    Same as -e '(require (lib " file " "coll "))'.

-M coll
    Same as -e '(require (lib " coll .ss" "coll "))'.

-r, --script
    Script mode: use as last flag for scripts. Same as -fmv-.

-i, --script-cd
    Like -r, but also sets the directory. Same as -dmv-.

-u, --require-script
    Like -r, but requires a module. Same as -tmv-.

-Z, --nogui
    Skip "class.ss" and "mred.ss" require.

-z, --stdio
    Use stdio REPL. Same as -ve '(read-eval-print-loop)'.

-K, --back
    Under Mac OS X, skip bringing the application to the foreground (in case it was started from a command line). -w, --awk Same as -l awk.ss.

-k n m
    Load executable-embedded code from file offset n to m.

-C, --main
    Like -r, then calls `main' with a list of argument strings. The first string in the list is the name of the loaded file, and the rest of the list contains leftover command-line arguments.

INITIALIZATION OPTIONS

-X dir, --collects dir
    Sets dir as the location of the main "collects" directory. If dir is relative, it is relative to the executable.

-S dir

--search dir
    Adds dir to the search path for library collections. If dir is relative, it is relative to the executable.

-U, --no-user-path
    Ignores PLTHOME, and omits the user-specific "collects" directory from the search path for library collections.

-x, --no-lib-path
    Skips trying to set current-library-collection-paths.

-q, --no-init-file
    Skips trying to load "~/.mredrc".

-N file, --name file
    Sets the program name to name.

-A, --no-argv
    Skips defining `argv' and `program'.

LANGUAGE SETTING OPTIONS

-g, --case-sens
    Identifiers and symbols are initially case-sensitive (the default).

-G, --case-insens
    Identifiers and symbols are initially case-insensitive.

-s, --set-undef
    Set! works on undefined identifiers.

MISCELLANEOUS OPTIONS

--
    No argument following this switch is used as a switch.

-p, --persistent
    Catches AIX SIGDANGER (low page space) signal. (AIX only)

-m, --mute-banner
    Suppresses the startup banner.

-v, --version
    Suppresses the read-eval-print loop.

-V, --yield
    Like -v, also suppresses (yield 'wait).

-h, --help
    Shows help for command-line arguments.

-Rfile, --restore file
    Restores an image; must be the only switch. (Special versions only)

OPTION CONVENTIONS
Multiple single-letter switches can be collapsed, with arguments placed after the collapsed switches; the first collapsed switch cannot be --. E.g.: -vfme file expr is the same as -v -f file -m -e expr.

Extra arguments following the last switch are put into the Scheme global variable `argv' as a vector of strings. The name used to start MrEd is put into the global variable `program' as a string.

Extra arguments after a --restore file are returned as a vector of strings to the continuation of the `write-image-to-file' call that created the image.

Expressions/files are evaluated/loaded in order as provided, including calls to main implied by --main, embedded segments loaded by -k, and so on. An uncaught exception during an evaluation/load causes later evaluations/loads to be skipped.

The current-library-collections-paths parameter is automatically set before any expressions/files are evaluated/loaded, unless the -x or --no-lib-path switch is used.

EXECUTABLE NAME
If the executable name has the form scheme-dialect , then the command line is effectively prefixed with
-qAeC '(require (lib "init.ss" "script-lang" "dialect "))' The first actual command-line argument thus serves as the name of a file to load. The file should define main, which is called with the command-line arguments---starting with the loaded file name---as a list of immutable strings.

FILES
The file "~/.mredrc" is loaded before any provided expressions/files are evaluated/loaded, unless the -q or --no-init-file switch is used.

Unless the -U or --no-user-path switch is provided, the library collections search path is read from the PLTCOLLECTS environment variable (as a colon-separated list of paths). Where the empty path appears in PLTCOLLECTS, it is replaced with the default collections directory search path.

FURTHER INFORMATION
For further information on MrEd, please consult the on-line documentation and other information available at

http://www.plt-scheme.org/software/mred/

BUGS
Submit bug reports via
http://bugs.plt-scheme.org/ (encouraged) or by e-mail to
bugs@plt-scheme.org (discouraged)

AUTHOR
MrEd was implemented by Matthew Flatt (mflatt@plt-scheme.org), Robert Bruce Findler (robby@plt-scheme.org), and John Clements (clements@plt-scheme.org), based on MzScheme.

SEE ALSO
help-desk(1), mzscheme(1), drscheme(1)